<template>
  <v-ons-page>
    <v-ons-toolbar>
      <div class="left">
        <v-ons-icon
          icon="ion-ios-arrow-back"
          size="lg"
          @click="redirect(previousUrl, {tab: 'setting'})"
        ></v-ons-icon>
      </div>
      <div class="center">Import Account</div>
      <div class="right">
        <v-ons-toolbar-button icon="ion-navicon"></v-ons-toolbar-button>
      </div>
    </v-ons-toolbar>

    <div class="import-account-container">
      <p>
        Enter or Scan your
        <strong>Secret Key</strong> to import your account.
      </p>
      <q-reader :onDetectQR="onDetectSk" :scanning="showScanner" />
      <v-ons-button
        v-if="showScanner"
        class="new-message-btn"
        modifier="quiet"
        @click="onClickQRScanner"
      >Close QR Scanner</v-ons-button>

      <div class="secret-input-container">
        <input placeholder="Secret key" v-model="secretKey" class="username-input secret-key-input" />
        <v-ons-button modifier="quiet" @click="onClickQRScanner" class="qr-code-btn">
          <img src="../../assets/qrcode.png" alt="qr-code" />
        </v-ons-button>
      </div>
      <v-ons-button class="create-user-btn default-btn" @click="onImportAccount">Import Account</v-ons-button>
    </div>
  </v-ons-page>
</template>

<script>
import Vue from "vue";
import "onsenui/css/onsenui.css";
import "onsenui/css/onsen-css-components.css";
import VueOnsen from "vue-onsenui/esm";
import OnsenComponents from "~/components/Onsen";
import ChatText from "~/components/ChatText";
import ChatInput from "~/components/ChatInput";
import QReader from "~/components/QReader";
import utils from "../../assets/utils";
import { mapActions } from "vuex";

Vue.use(VueOnsen);
Object.values(OnsenComponents).forEach(c => Vue.component(c.name, c));

export default {
  components: {
    QReader
  },
  data: function() {
    return {
      secretKey: "",
      previousUrl: "/",
      showScanner: false
    };
  },
  computed: {},
  beforeRouteEnter(to, from, next) {
    next(vm => {
      vm.previousUrl = from.path;
    });
  },
  methods: {
    ...mapActions({
      addWallet: "wallet/addWallet"
    }),
    onDetectSk(sk) {
      this.secretKey = sk;
      this.showScanner = false;
    },
    redirect(url, option) {
      this.$router.push(url);
      if (url === "/" && option) {
      }
    },
    onClickAddSign() {},
    onClickQRScanner() {
      this.showScanner = !this.showScanner;
    },
    async onImportAccount() {
      let { handle, entry } = await utils.importWallet(this.secretKey);
      let wallet = {
        handle: handle,
        entry: entry
      };
      console.log(wallet);
      utils.saveWallet(wallet);
      this.addWallet(wallet);
      this.$router.push("/?tabIndex=0");
    }
  }
};
</script>

<style>
.import-account-container {
  text-align: center;
  margin-top: 30px;
}
.secret-key-input {
  margin-right: 5px;
}
.qr-code-btn {
  height: 40px;
  padding: 5px;
}
.secret-input-container {
  display: flex;
  justify-content: center;
  align-items: center;
}
</style>
